<template>
  <div class="h5-container">
    <van-nav-bar title="事故举报" @click-left="onClickLeft" @click-right="handAdd('add','XY')">
      <template #right>
        <van-icon name="add" size="25" color="#000" />
      </template>
    </van-nav-bar>
    <van-search v-if="false" v-model="query.discovererDesc" show-action placeholder="请输入发现人" @search="onRefresh"
      @cancel="handdelect" />

    <!-- 项目列表 -->
    <van-pull-refresh v-model="isRefreshing" success-text="刷新成功" @refresh="onRefresh">
      <van-list v-model:loading="isLoading" :finished="isFinished" finished-text="没有更多了" offset="200" @load="onLoad">
        <div v-for="(item, idx) in resultData" :key="item.id">
          <van-swipe-cell @open="handleSwipeOpen(item,idx)" @close="handleSwipeClose(item,idx)" title-style="color: #007aff" style="height: 80px;" :ref="el => getSwipeCellRef(el, idx)">
            <template #default>
              <div class="swipe-cell-default">
                <van-cell style="min-height: 100px; padding: 0 0 0 0; display: flex; align-items: flex-start;" @click="handAdd('look',item)">
                  <template #title>
                    <div class="cell-title">
                      {{ item.hdDescription }}
                    </div>
                  </template>
                  <template #label>
                    <div>事故地点：{{ item.accidentLocation }}</div>
                    <div>发生时间：{{ item.accidentTime }}</div>
                    <div>事故类型：{{ item.accidentType }}</div>
                    <div>事故等级：{{ item.accidentLevel }}</div>
                  </template>
                </van-cell>
                <div class="swipe-cell-default-icon">
                  <van-icon v-if="openStatus[idx]" name="arrow-double-left" @click.stop="openSwipe(idx)" />
                  <van-icon v-else name="arrow-double-right" @click.stop="closeSwipe(idx)" />
                </div>
              </div>
            </template>

            <template #right>
              <van-button square class="edit-button" text="编辑" @click="handAdd('edit', item)" />
              <van-button square class="delete-button" text="删除" @click="handleDelete(item, idx)" />
            </template>
          </van-swipe-cell>
        </div>

      </van-list>
    </van-pull-refresh>


    <!-- 删除确认弹窗 -->
    <van-dialog v-model:show="deleteDialogVisible" show-cancel-button @confirm="confirmDelete">
      <template #title>
        <div>删除确认</div>
      </template>
      <div style="padding: 30px;">确定要删除该事故记录吗？</div>
    </van-dialog>

  </div>
</template>

<script setup>
import { ref, reactive, onMounted, getCurrentInstance, nextTick, toRaw } from 'vue';
import { Dialog, showDialog, showSuccessToast, showToast, Toast } from 'vant';

const { proxy } = getCurrentInstance();

const onClickLeft = () => {
  history.back();
};
const headers = ref({
  token: localStorage.getItem('token'),
  userId: localStorage.getItem('userId'),
  dept: JSON.parse(localStorage.getItem('dept'))[0].deptCode
});
const switchIconState = (idx) => {
  openStatus.value[idx] = !openStatus.value[idx]
  openStatus.value = new Array(resultData.value.length).fill(true);
}

// const onClickRight = () =>{
//   searchShow.value = !searchShow.value;
// }

const searchShow = ref(false);
const query = ref({
  discovererDesc: '',
  hdSelect:'隐患举报'
});

function formatDate(date, format) {
  const year = date.getFullYear();
  const month = date.getMonth() + 1;
  const day = date.getDate();
  const hours = date.getHours();
  const minutes = date.getMinutes();
  const seconds = date.getSeconds();

  return format
    .replace('yyyy', year)
    .replace('MM', month.toString().padStart(2, '0'))
    .replace('dd', day.toString().padStart(2, '0'))
    .replace('HH', hours.toString().padStart(2, '0'))
    .replace('mm', minutes.toString().padStart(2, '0'))
    .replace('ss', seconds.toString().padStart(2, '0'));
}

const tableData = ref([]);
const selectedRows = ref([]);
const dialogVisibleLook = ref(false);
const deleteDialogVisible = ref(false);
const currentDeleteItem = ref([]);
const dialogVisible = ref(false);
const dialogVisibleFile = ref(false);
const date = ref(null);

const kz = ref(true);
const handAdd = async (flag,item) => {
  if('add'===flag) {
    // 将表单数据置空
    resetForma();
    //todo 编辑页面
    proxy.$router.push({
      path: '/accidentManager/accidentJuBao/accidentJuBao_edit/index',
      query: {
        flag:'add'
      }
    });
  }else if('edit'===flag) { 
    proxy.$router.push({
      path: '/accidentManager/accidentJuBao/accidentJuBao_edit/index',
      query: {
        id:item.id,
        flag:'edit'
      }
    })
  }else {
    proxy.$router.push({
      path: '/accidentManager/accidentJuBao/accidentJuBao_edit/index',
      query: {
        id:item.id,
        flag:'look'
      }
    })
  }
};
// 定义表单数据
const form = ref({
  hdPicId: '',
  hdId: '',
  hdType: '',
  discoveryTime: '',
  hdSubtype: '',
  discoverer: '',
  discovererOther: '',
  hdDescription: '',
  hdLevel: '',
  bz: '',
  hdLocation: '',
  picBefore: '',

  equipmentId: '',
  hdmanageLevel: '',
  handlingProcesses: '',
  companyId: '',
  repairLeader: '',
  repairOther: '',
  repairSuggest: '',
  repairDdl: '',
  repairDept: '',
  acceptLeader: '',
  acceptOther: '',
  picAfter: '',
  picTemp: '',
  repairDescription: '',
  discovererDept: '',
  discovererDeptCode: '',
  hdLocationCode: '',
  hdLocationName: '',

  status: '',


  hdSelect: '隐患举报',
  id: ''
});
const resetForma = () => {
  form.value = {
    hdPicId: '',
    hdId: '',
    hdType: '',
    discoveryTime: '',
    hdSubtype: '',
    discoverer: '',
    discovererOther: '',
    hdDescription: '',
    hdLevel: '',
    bz: '',
    hdLocation: '',
    picBefore: '',

    equipmentId: '',
    hdmanageLevel: '',
    handlingProcesses: '',
    companyId: '',
    repairLeader: '',
    repairOther: '',
    repairSuggest: '',
    repairDdl: '',
    repairDept: '',
    acceptLeader: '',
    acceptOther: '',
    picAfter: '',
    picTemp: '',
    repairDescription: '',
    status: '',
    discovererDept: '',
    discovererDeptCode: '',
    hdLocationCode: '',
    hdLocationName: '',

    hdSelect: '隐患举报',
    id: ''
  };
};

const isRefreshing = ref(false);
const isLoading = ref(false);
const isFinished = ref(false);
const currentPage = ref(1);
const pageSize = ref(10);
const totalRows = ref(0);
const resultData = ref([]);

const getTableData = async () => {
  const url = 'sgsafe/AccidentDirect/query';
  const param = {
    page: currentPage.value,
    rows: pageSize.value,
    params: JSON.stringify(query.value)
  };
  const response = await proxy.$axios.get(url, param);
  if (response.data.code === 0) {
    tableData.value = response.data.data.records;
    totalRows.value = response.data.data.total;
    // tableData.value.forEach(item => {
    //   switch (item.status) {
    //     case '0':
    //       item.status = '隐患登记';
    //       break;
    //     case '1':
    //       item.status = '隐患分析确认';
    //       break;
    //     case '2':
    //       item.status = '隐患整改';
    //       break;
    //     case '3':
    //       item.status = '隐患验收';
    //       break;
    //     case '4':
    //       item.status = '隐患销号';
    //       break;
    //     case '5':
    //       item.status = '结束';
    //       break;
    //     case '-1':
    //       item.status = '待提交';
    //       break;
    //   }
    // });
  } else {
    showToast({
      type: 'error',
      message: '操作失败！' + response.data.msg
    });
  }
};

const onRefresh = () => {
  basicReset();
  onLoad();
};

const onLoad = async () => {
  if (isRefreshing.value) {
    resultData.value = [];
    currentPage.value = 1;
    isRefreshing.value = false;
  }
  try {
    await getTableData();
    if (pageSize.value * currentPage.value < totalRows.value) {
      resultData.value = [...resultData.value, ...tableData.value];
      openStatus.value = new Array(resultData.value.length).fill(true);
      currentPage.value++;

    } else {
      resultData.value = [...resultData.value, ...tableData.value];
      openStatus.value = new Array(resultData.value.length).fill(true);
      isFinished.value = true;
    }
  } catch (error) {
    console.log(error);
    isFinished.value = true;
  } finally {
    isLoading.value = false;
  }
};
/* 通用方法： 重置list数据 */
const basicReset = () => {
  isFinished.value = false;
  isLoading.value = true;
  currentPage.value = 1;
  resultData.value = [];
};

/*onMounted(() => {
  handleSearch();
});

const handleSearch = () => {
/!*  currentPage.value = 1;
  isFinished.value = false;
  tableData.value = [];*!/
  basicReset()
  onLoad()
};*/

const handdelect = () => {
  query.value.discoverer = '';
  onRefresh()
};

const handleDetailLook = (row) => {
  form.value = { ...row };
  proxy.$router.push({
    name: 'taiZhang_detail',
    query: {
      form: form.value.id
    }
  });
  // dialogVisibleLook.value = true;
};
const deleteId = ref('')
const handleDelete = (item, idx) => {
  openStatus.value[idx] = !openStatus.value[idx]
  openStatus.value = new Array(resultData.value.length).fill(true);
  deleteId.value = item.id
  deleteDialogVisible.value = true;
};

const confirmDelete = () => {
  var url = 'sgsafe/AccidentDirect/remove';
  var param = {
    id: deleteId.value
  };
  proxy.$axios.get(url, param).then(response => {
    if (response.data.code == 0) {
      showToast({
        type: 'success',
        message: '删除成功'
      });
      onRefresh();
    } else {
      showToast({
        type: 'fail',
        message: '操作失败！' + response.data.msg
      });
    }
  });
};

const edits = (row) => {
  form.value = { ...row };
  if (row.workId) {
    sessionStorage.setItem('workflowQuery', JSON.stringify({
      flowId: row.flowId,
      workId: row.workId,
      trackId: row.trackId,
      // subjectionId: '0703E25C35BD11B2A553E9317BF53B18',
      // subjectionId: '0703E25C35BD11B2A553E9317BF53B18',
      type: '1',
      date: new Date().getTime()
    }));
    proxy.$router.push({
      path: '/yinhuan/JuBaohdLedger_detail'
    });
  } else {
    proxy.$router.push({
      path: '/yinhuan/JuBaoregistration_edit/index',
      query: {
        id: form.value.id
      }
    });
  }

};


const resetForm = () => {
  form.value = {
    projectName: '',
    projectLeader: '',
    phone: '',
    dept: ''
  };
};

const baocun = () => {
  nextTick(() => {
    if (form.value.hdSelect === '隐患举报') {
      form.value.status = '0';
    } else if (form.value.hdSelect === '下发隐患') {
      form.value.status = '2';
    } else {
      form.value.status = '-1';
    }
  });
  // 原有保存逻辑保持不变
  var url = 'sgsafe/JuBaoHiddendanger/save';
  var param = {
    json: JSON.stringify(form.value)
  };
  proxy.$axios.post(url, param).then(response => {
    if (response.data.code == '0') {
      showSuccessToast('保存成功！');
      getTableData();
      orJsons();
      // clearDeptUsers()
    } else {
      showToast({
        type: 'fail',
        message: '操作失败！' + response.data.msg
      });
    }
  });
};

//处理人员code
const repairLL = ref('');
const repairOO = ref('');
const acceptLL = ref('');
const orJsons = () => {
  // console.log('forms',form.value)
  if (form.value.hdSelect === '隐患举报') {
    nextTick(() => {
      nextTick(() => {
        repairLL.value = qq('repairLL', form.value.discoverer);//隐患发现人
        nextTick(() => {
          repairOO.value = qq('repairOO', form.value.discovererOther);//其他隐患发现人
          nextTick(() => {
            acceptLL.value = qq('acceptLL', form.value.discoverer);//隐患销号人
          });
        });
      });

      // acceptOO.value = qq('acceptOO', form.value.acceptOther)
    });
  } else {
    // console.log('noiajdoifjpoewjfopjp')
    nextTick(() => {
      nextTick(() => {
        repairLL.value = qq('repairLL', form.value.acceptLeader);//隐患发现人
        nextTick(() => {
          repairOO.value = qq('repairOO', form.value.acceptOther);//其他隐患发现人
          nextTick(() => {
            acceptLL.value = qq('acceptLL', form.value.discoverer);//隐患销号人
          });
        });
      });

      // acceptOO.value = qq('acceptOO', form.value.acceptOther)
    });
  }
};

const jsons = ref({});
const qq = (a, val) => {
  let aa = '';
  var url = 'sgsafe/JuBaoHiddendanger/qqId';
  var param = {
    params: val
  };
  proxy.$axios.post(url, param).then(response => {
    if (response.data.code == 0) {

      aa = response.data.data;
      switch (a) {
        case 'repairLL':
          repairLL.value = response.data.data;
          // console.log('repairLL',repairLL.value);
          break;
        case 'repairOO':
          repairOO.value = response.data.data;
          // console.log('repairOO',repairLL.value);
          break;
        case 'acceptLL':
          acceptLL.value = response.data.data;
          // console.log('acceptLL',repairLL.value);
          break;
        default:
          break;
      }
      jsons.value = {
        hdConfirm: repairLL.value,
        hdConfirmO: repairOO.value,
        hdCancel: acceptLL.value
      };

      // 处理函数
      function processValue(value) {
        // 将逗号替换为分号
        const replacedValue = value.replace(/,/g, ';');
        // 分割值
        const parts = replacedValue.split(';');
        // 每个部分前加上 U_
        const processedParts = parts.map(part => `U_${part.trim()}`);
        // 重新组合
        return processedParts.join(';');
      }

      // 处理整个对象
      const processedData = {};
      for (const key in jsons.value) {
        if (jsons.value.hasOwnProperty(key)) {
          processedData[key] = processValue(jsons.value[key]);
        }
      }

      console.log('对象', toRaw(processedData));

      let b = {
        acceptL: processedData.hdConfirm,
        acceptO: processedData.hdConfirmO,
        id: form.value.id
      };

      if (form.value.hdSelect === '即查即改') {
        b = {
          hdFxr: processedData.hdCancel,
          id: form.value.id
        };
      }

      if (form.value.hdSelect === '隐患举报') {
        b = {
          // hdConfirm: processedData.hdConfirm,
          // hdConfirmO: processedData.hdConfirmO,
          id: form.value.id
        };
      }

      const aaa = JSON.stringify(toRaw(b));
      sessionStorage.setItem('variables', aaa);
      console.log('aaa', aaa);
    } else {
      showToast({
        type: 'fail',
        message: '操作失败！' + response.data.msg
      });
    }
  });
  return aa;
};

const reback = () => {
  // 返回逻辑
};

const deleteRow = (row) => {
  selectedRows.value = [row];
  handleDelete(row);
};

const deleteRowa = (row) => {
  deleteRow(row);
};

const bm = (val) => {
  // 部门选择逻辑
};

//提交审批流程
import { workflowSubmit, workflowCancel } from '@/tools/workflow.js';

const flowId = ref('');
flowId.value = 'hdRwardReportingId';
const handleSubmit2 = (val, idx) => {
  openStatus.value[idx] = !openStatus.value[idx]
  openStatus.value = new Array(resultData.value.length).fill(true);
  console.log('提交');
  console.log('selectedRows', selectedRows.value);
  let row = val;
  form.value = { ...row }
  form.value.workCreate = headers.value.dept;

  let b = {
    id: form.value.id,
    hdConfirm:form.value.hdConfirm
  }
  const aaa = JSON.stringify(toRaw(b))
  sessionStorage.setItem('variables', aaa)

  if (form.value.hdSelect === '隐患举报') {
    flowId.value = 'hdRwardReportingId'
  } 

  console.log('----');
  console.log(flowId.value);
  console.log(sessionStorage.getItem('variables'));
  console.log(row.workId);
  console.log(row.trackId);
  let titles = '隐患举报'
  showDialog({
    title: '提示',
    message: '确定提交审批？',
    showCancelButton: true,
    confirmButtonText: '确定',
    type: 'warning',
    cancelButtonText: '取消'
  }
  ).then(() => {
    return workflowSubmit(
      flowId.value,
      '隐患举报',
      '初始化提交',
      // JSON.stringify({}),
      sessionStorage.getItem('variables'),
      row.workId,
      row.trackId);
  }).then((result) => {
    if (result.status === 'success') {
      // 将结果返回的workId和trackId保存
      var url = 'sgsafe/JuBaoHiddendanger/saveProcessInfo';
      console.log('id', result, row.id);
      var process = {
        'id': form.value.id,
        'workId': result.workId,
        'trackId': result.trackId
      };
      var param = {
        json: JSON.stringify(process)
      };
      proxy.$axios.post(url, param).then(response => {
        if (response.data.code === 0) {
          form.value = response.data.data;
          console.log('我要进来啦保存成功');
          showToast({
            type: 'success',
            message: '提交审批成功'
          });
          onRefresh()
        }
      });
    } else {
      showToast({
        type: 'error',
        message: '提交审批失败，' + result.msg
      });
    }
  }).catch(() => {
    showToast({
      type: 'info',
      message: '已取消提交'
    });
  });
};


const getStatusClass = (status) => {
  switch (status) {
    case '-1':
      return 'status-pending';
    case '0':
      return 'status-registered';
    case '1':
      return 'status-analyzing';
    case '2':
      return 'status-rectifying';
    case '3':
      return 'status-accepting';
    case '4':
      return 'status-closed';
    case '5':
      return 'status-finished';
    default:
      return 'status-unknown';
  }
};

/**
 * 按钮实现swipe-cell滑动
 */
const openStatus = ref([])
const swipeCellRefs = ref([])
const getSwipeCellRef = (el, index) => {
  if (el) {
    swipeCellRefs.value[index] = el;
  }
}
const openSwipe = (idx) => {
  openStatus.value = new Array(resultData.value.length).fill(true);
  if (idx >= 0 && idx < swipeCellRefs.value.length) {
    openStatus.value[idx] = false
    swipeCellRefs.value[idx].open('right')
  }
  document.addEventListener('click', handleDocumentClick)
}
/**
 * 当点击滑动单元格时，开始监听点击事件
 */
const handleDocumentClick = (event) => {
  openStatus.value = new Array(resultData.value.length).fill(true);
}

const closeSwipe = (idx) => {
  if (idx >= 0 && idx < swipeCellRefs.value.length) {
    openStatus.value[idx] = true
    swipeCellRefs.value[idx].close()
  }
}

/**滑动监听**/
const handleSwipeOpen = (item,idx) =>{
  console.log('handleSwipeOpen', idx)
  console.log('handleSwipeOpen数据', item)
  openStatus.value[idx] = false
}

const handleSwipeClose = (item,idx) =>{
  openStatus.value[idx] = true
  console.log('handleSwipeClose', idx)
  console.log('handleSwipeClose数据', item)
}

</script>

<style scoped>
.h5-container {
  width: 100%;
  padding: 5px;
  box-sizing: border-box;
}

.status-pending {
  background-color: #fff3cd;
  color: #856404;
  padding: 2px 4px;
  border-radius: 4px;
}

.status-registered {
  background-color: #d1ecf1;
  color: #0c5460;
  padding: 2px 4px;
  border-radius: 4px;
}

.status-analyzing {
  background-color: #fff8e1;
  color: #ff8f00;
  padding: 2px 4px;
  border-radius: 4px;
}

.status-rectifying {
  background-color: #e8f5e9;
  color: #2e7d32;
  padding: 2px 4px;
  border-radius: 4px;
}

.status-accepting {
  background-color: #e3f2fd;
  color: #1565c0;
  padding: 2px 4px;
  border-radius: 4px;
}

.status-closed {
  background-color: #f8bbd0;
  color: #b71c1c;
  padding: 2px 4px;
  border-radius: 4px;
}

.status-finished {
  background-color: #e8eaf6;
  color: #311b92;
  padding: 2px 4px;
  border-radius: 4px;
}

.status-unknown {
  background-color: #efebe9;
  color: #424242;
  padding: 2px 4px;
  border-radius: 4px;
}

.cell-title {
  display: -webkit-box;
  /* 旧版弹性盒子模型 */
  -webkit-box-orient: vertical;
  /* 内容垂直排列 */
  -webkit-line-clamp: 2;
  /* 限制显示行数 */
  overflow: hidden;
  /* 超出隐藏 */
  text-overflow: ellipsis;
  /* 省略号 */
  line-height: 1.5;
  /* 可选：设置行高 */
  max-height: calc(1.5em * 3);
  /* 可选：根据行高限制最大高度 */
  font-size: 16px;
  font-weight: bold;
  color: #333;
  /* 字号 */
}

.swipe-cell-default {
  display: flex;
  background-color: #ffffff;
  justify-content: center;
  align-items: center;
}

.swipe-cell-default-icon {
  width: 60px;
  display: flex;
  justify-content: center;
}

.delete-button {
  height: 100%;
  border: none;
  color: #ff0000;
  background-image: url('@/assets/img/del.png');
  background-size: auto 100%;
  background-repeat: no-repeat;
}
.edit-button {
  height: 100%;
  border: none;
  color: #F9CC9D;
  background-image: url('@/assets/img/edit.png');
  background-size: auto 100%;
  background-repeat: no-repeat;
}

.submit-button {
  height: 100%;
  border: none;
  color: #07c160;
  background-image: url('@/assets/img/sub.png');
  background-size: auto 100%;
  background-repeat: no-repeat;
}

.subsuccess {
  height: 100%;
  border: none;
  color: #07c160;
  background-image: url('@/assets/img/sub1.png');
  background-size: auto 100%;
  background-repeat: no-repeat;
}
</style>
